diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/model/lr-wpan-mac.h ns-3.31/src/lr-wpan/model/lr-wpan-mac.h
--- ns-3.30.1/src/lr-wpan/model/lr-wpan-mac.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lr-wpan/model/lr-wpan-mac.h	2020-06-27 17:38:30.000000000 -0700
@@ -571,34 +987,79 @@
   {
     uint8_t txQMsduHandle; //!< MSDU Handle
     Ptr<Packet> txQPkt;    //!< Queued packet
-  };
 
+  };
+  /**
+   * Helper structure for managing indirect transmission queue elements.
+   */
+  struct IndTxQueueElement
+  {
+    uint8_t txQMsduHandle; //!< MSDU Handle.
+    Ptr<Packet> txQPkt;    //!< Queued packet.
+    Time expireTime;       //!< The expiration time of the packet in the indirect transmission queue.
+  };
+  /**
+   * Called to send a single beacon frame.
+   */
+  void SendOneBeacon (void);
+  /**
+   * Called to begin the Contention Free Period (CFP) in a
+   * beacon-enabled mode.
+   *
+   * \param superframeType The incoming or outgoing superframe reference
+   */
+  void StartCFP (SuperframeType superframeType);
+  /**
+   * Called to begin the Contention Access Period (CAP) in a
+   * beacon-enabled mode.
+   *
+   * \param superframeType The incoming or outgoing superframe reference
+   */
+  void StartCAP (SuperframeType superframeType);
+  /**
+   * Start the Inactive Period in a beacon-enabled mode.
+   *
+   * \param superframeType The incoming or outgoing superframe reference
+   *
+   */
+  void StartInactivePeriod (SuperframeType superframeType);
+  /**
+   * Called after the end of an INCOMING superframe to start the moment a
+   * device waits for a new incoming beacon.
+   */
+  void AwaitBeacon (void);
+  /**
+   * Called if the device is unable to locate a beacon in the time set by MLME-SYNC.request.
+   */
+  void BeaconSearchTimeout (void);
   /**
    * Send an acknowledgment packet for the given sequence number.
    *
    * \param seqno the sequence number for the ACK
    */
   void SendAck (uint8_t seqno);
-
   /**
    * Remove the tip of the transmission queue, including clean up related to the
    * last packet transmission.
    */
   void RemoveFirstTxQElement ();
-
   /**
    * Change the current MAC state to the given new state.
    *
    * \param newState the new state
    */
   void ChangeMacState (LrWpanMacState newState);
-
   /**
    * Handle an ACK timeout with a packet retransmission, if there are
    * retransmission left, or a packet drop.
    */
   void AckWaitTimeout (void);
-
+  /**
+   * After a successful transmission of a frame (beacon, data) or an ack frame reception,
+   * the mac layer wait an Interframe Space (IFS) time and triggers this function
+   * to continue with the MAC flow.
+   */
+  void IfsWaitTimeout (void);
   /**
    * Check for remaining retransmissions for the packet currently being sent.
    * Drop the packet, if there are no retransmissions left.
@@ -606,13 +1067,27 @@
    * \return true, if the packet should be retransmitted, false otherwise.
    */
   bool PrepareRetransmission (void);
-
   /**
    * Check the transmission queue. If there are packets in the transmission
    * queue and the MAC is idle, pick the first one and initiate a packet
    * transmission.
    */
   void CheckQueue (void);
+  /**
+   * Constructs a Superframe specification field from the local information,
+   * the superframe Specification field is necessary to create a beacon frame.
+   */
+  SuperframeField GetSuperframeField (void);
+  /**
+   * Constructs the Guaranteed Time Slots (GTS) Fields from local information
+   * The GTS Fields are part of the beacon frame.
+   */
+  GtsFields GetGtsFields (void);
+  /**
+    * Constructs Pending Address Fields from the local information,
+    * the Pending Address Fields are part of the beacon frame.
+    */
+  PendingAddrFields GetPendingAddrFields (void);
 
   /**
    * The trace source fired when packets are considered as successfully sent
@@ -625,7 +1100,6 @@
    * \see class CallBackTraceSource
    */
   TracedCallback<Ptr<const Packet>, uint8_t, uint8_t > m_sentPktTrace;
-
   /**
    * The trace source fired when packets come into the "top" of the device
    * at the L3/L2 transition, when being queued for transmission.
@@ -633,7 +1107,6 @@
    * \see class CallBackTraceSource
    */
   TracedCallback<Ptr<const Packet> > m_macTxEnqueueTrace;
-
   /**
    * The trace source fired when packets are dequeued from the
    * L3/l2 transmission queue.
@@ -641,14 +1114,12 @@
    * \see class CallBackTraceSource
    */
   TracedCallback<Ptr<const Packet> > m_macTxDequeueTrace;
-
   /**
    * The trace source fired when packets are being sent down to L1.
    *
    * \see class CallBackTraceSource
    */
   TracedCallback<Ptr<const Packet> > m_macTxTrace;
-
   /**
    * The trace source fired when packets where successfully transmitted, that is
    * an acknowledgment was received, if requested, or the packet was
@@ -657,7 +1128,6 @@
    * \see class CallBackTraceSource
    */
   TracedCallback<Ptr<const Packet> > m_macTxOkTrace;
-
   /**
    * The trace source fired when packets are dropped due to missing ACKs or
    * because of transmission failures in L1.
@@ -665,7 +1135,6 @@
    * \see class CallBackTraceSource
    */
   TracedCallback<Ptr<const Packet> > m_macTxDropTrace;
-
   /**
    * The trace source fired for packets successfully received by the device
    * immediately before being forwarded up to higher layers (at the L2/L3
@@ -674,7 +1143,6 @@
    * \see class CallBackTraceSource
    */
   TracedCallback<Ptr<const Packet> > m_macPromiscRxTrace;
-
   /**
    * The trace source fired for packets successfully received by the device
    * immediately before being forwarded up to higher layers (at the L2/L3
@@ -683,7 +1151,6 @@
    * \see class CallBackTraceSource
    */
   TracedCallback<Ptr<const Packet> > m_macRxTrace;
-
   /**
    * The trace source fired for packets successfully received by the device
    * but dropped before being forwarded up to higher layers (at the L2/L3
@@ -692,7 +1159,6 @@
    * \see class CallBackTraceSource
    */
   TracedCallback<Ptr<const Packet> > m_macRxDropTrace;
-
   /**
    * A trace source that emulates a non-promiscuous protocol sniffer connected
    * to the device.  Unlike your average everyday sniffer, this trace source
@@ -732,7 +1198,6 @@
    * \see class CallBackTraceSource
    */
   TracedCallback<Ptr<const Packet> > m_promiscSnifferTrace;
-
   /**
    * A trace source that fires when the LrWpanMac changes states.
    * Parameters are the old mac state and the new mac state.
@@ -742,87 +1207,133 @@
    * TracedValue.
    */
   TracedCallback<LrWpanMacState, LrWpanMacState> m_macStateLogger;
-
   /**
    * The PHY associated with this MAC.
    */
   Ptr<LrWpanPhy> m_phy;
-
   /**
    * The CSMA/CA implementation used by this MAC.
    */
   Ptr<LrWpanCsmaCa> m_csmaCa;
-
+  /**
+   * This callback is used to notify incoming beacon packets to the upper layers.
+   * See IEEE 802.15.4-2011, section 6.2.4.1.
+   */
+  MlmeBeaconNotifyIndicationCallback m_mlmeBeaconNotifyIndicationCallback;
+  /**
+   * This callback is used to indicate the loss of synchronization with a coordinator.
+   * See IEEE 802.15.4-2011, section 6.2.13.2.
+   */
+  MlmeSyncLossIndicationCallback m_mlmeSyncLossIndicationCallback;
+  /**
+   * This callback is used to report the status after a device send data command request to
+   * the coordinator to transmit data.
+   * See IEEE 802.15.4-2011, section 6.2.14.2.
+   */
+  MlmePollConfirmCallback m_mlmePollConfirmCallback;
+  /**
+   * This callback is used to report the start of a new PAN or
+   * the begin of a new superframe configuration.
+   * See IEEE 802.15.4-2006, section 7.1.14.2.
+   */
+  MlmeStartConfirmCallback m_mlmeStartConfirmCallback;
   /**
    * This callback is used to notify incoming packets to the upper layers.
    * See IEEE 802.15.4-2006, section 7.1.1.3.
    */
   McpsDataIndicationCallback m_mcpsDataIndicationCallback;
-
   /**
    * This callback is used to report data transmission request status to the
    * upper layers.
    * See IEEE 802.15.4-2006, section 7.1.1.2.
    */
   McpsDataConfirmCallback m_mcpsDataConfirmCallback;
-
   /**
    * The current state of the MAC layer.
    */
   TracedValue<LrWpanMacState> m_lrWpanMacState;
-
+  /**
+   * The current period of the incoming superframe.
+   */
+  TracedValue<SuperframeStatus> m_incSuperframeStatus;
+  /**
+   * The current period of the outgoing superframe.
+   */
+  TracedValue<SuperframeStatus> m_outSuperframeStatus;
   /**
    * The current association status of the MAC layer.
    */
   LrWpanAssociationStatus m_associationStatus;
-
   /**
    * The packet which is currently being sent by the MAC layer.
    */
   Ptr<Packet> m_txPkt;  // XXX need packet buffer instead of single packet
-
   /**
    * The short address used by this MAC. Currently we do not have complete
    * extended address support in the MAC, nor do we have the association
    * primitives, so this address has to be configured manually.
    */
   Mac16Address m_shortAddress;
-
   /**
    * The extended address used by this MAC. Extended addresses are currently not
    * really supported.
    */
   Mac64Address m_selfExt;
-
   /**
    * The transmit queue used by the MAC.
    */
   std::deque<TxQueueElement*> m_txQueue;
-
+  /**
+   * The indirect transmit queue used by the MAC pending messages.
+   */
+  std::deque<IndTxQueueElement*> m_indTxQueue;
   /**
    * The number of already used retransmission for the currently transmitted
    * packet.
    */
   uint8_t m_retransmission;
-
   /**
    * The number of CSMA/CA retries used for sending the current packet.
    */
   uint8_t m_numCsmacaRetry;
-
   /**
    * Scheduler event for the ACK timeout of the currently transmitted data
    * packet.
    */
   EventId m_ackWaitTimeout;
-
   /**
    * Scheduler event for a deferred MAC state change.
    */
   EventId m_setMacState;
+  /**
+   * Scheduler event for Interframe spacing wait time.
+   */
+  EventId m_ifsEvent;
+  /**
+   * Scheduler event for generation of one beacon.
+   */
+  EventId m_beaconEvent;
+  /**
+   * Scheduler event for the end of the outgoing superframe CAP.
+   **/
+  EventId m_capEvent;
+  /**
+   * Scheduler event for the end of the outgoing superframe CFP.
+   */
+  EventId m_cfpEvent;
+  /**
+   * Scheduler event for the end of the incoming superframe CAP.
+   **/
+  EventId m_incCapEvent;
+  /**
+   * Scheduler event for the end of the incoming superframe CFP.
+   */
+  EventId m_incCfpEvent;
+  /**
+   * Scheduler event to track the incoming beacons.
+   */
+  EventId m_trackingEvent;
 };
-
-
 } // namespace ns3
 
 #endif /* LR_WPAN_MAC_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/model/lr-wpan-mac-header.cc ns-3.31/src/lr-wpan/model/lr-wpan-mac-header.cc
--- ns-3.30.1/src/lr-wpan/model/lr-wpan-mac-header.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lr-wpan/model/lr-wpan-mac-header.cc	2020-06-27 17:38:30.000000000 -0700
@@ -252,31 +252,24 @@
   return(m_auxKeyIdKeyIndex);
 }
 
-
 bool
 LrWpanMacHeader::IsBeacon (void) const
 {
   return(m_fctrlFrmType == LRWPAN_MAC_BEACON);
 }
 
-
-
 bool
 LrWpanMacHeader::IsData (void) const
 {
   return(m_fctrlFrmType == LRWPAN_MAC_DATA);
 }
 
-
-
 bool
 LrWpanMacHeader::IsAcknowledgment (void) const
 {
   return(m_fctrlFrmType == LRWPAN_MAC_ACKNOWLEDGMENT);
 }
 
-
-
 bool
 LrWpanMacHeader::IsCommand (void) const
 {
@@ -787,9 +780,6 @@
   return i.GetDistanceFrom (start);
 }
 
-// ----------------------------------------------------------------------------------------------------------
-
-
 } //namespace ns3
 
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc ns-3.31/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc
--- ns-3.30.1/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,240 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Ritsumeikan University, Shiga, Japan.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ *  Author: Alberto Gallegos Ramonet <ramonet@fc.ritsumei.ac.jp>
+ */
+
+#include "lr-wpan-mac-pl-headers.h"
+#include <ns3/simulator.h>
+
+namespace ns3 {
+
+/***********************************************************
+ *                Beacon MAC Payload
+ ***********************************************************/
+
+BeaconPayloadHeader::BeaconPayloadHeader ()
+{
+}
+
+NS_OBJECT_ENSURE_REGISTERED (BeaconPayloadHeader);
+
+TypeId
+BeaconPayloadHeader::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::BeaconPayloadHeader")
+    .SetParent<Header> ()
+    .SetGroupName ("LrWpan")
+    .AddConstructor<BeaconPayloadHeader> ()
+  ;
+  return tid;
+}
+
+TypeId
+BeaconPayloadHeader::GetInstanceTypeId (void) const
+{
+  return GetTypeId ();
+}
+
+uint32_t
+BeaconPayloadHeader::GetSerializedSize (void) const
+{
+  uint32_t size = 0;
+  size += m_superframeField.GetSerializedSize ();
+  size += m_gtsFields.GetSerializedSize ();
+  size += m_pndAddrFields.GetSerializedSize ();
+
+  return size;
+}
+
+void
+BeaconPayloadHeader::Serialize (Buffer::Iterator start) const
+{
+  Buffer::Iterator i = start;
+  i = m_superframeField.Serialize (i);
+  i = m_gtsFields.Serialize (i);
+  i = m_pndAddrFields.Serialize (i);
+}
+
+uint32_t
+BeaconPayloadHeader::Deserialize (Buffer::Iterator start)
+{
+  Buffer::Iterator i = start;
+  i = m_superframeField.Deserialize (i);
+  i = m_gtsFields.Deserialize (i);
+  i = m_pndAddrFields.Deserialize (i);
+
+  return i.GetDistanceFrom (start);
+}
+
+
+void
+BeaconPayloadHeader::Print (std::ostream &os) const
+{
+  os << "| Superframe Spec Field | = " << m_superframeField
+     << "| GTS Spec Field | = " << m_gtsFields.GetGtsSpecField ()
+     << "| Pending Spec Field| =" << m_pndAddrFields.GetPndAddrSpecField ();
+}
+
+
+void
+BeaconPayloadHeader::SetSuperframeSpecField (SuperframeField sf)
+{
+  m_superframeField = sf;
+}
+
+void
+BeaconPayloadHeader::SetGtsFields (GtsFields gtsFields)
+{
+  m_gtsFields = gtsFields;
+}
+
+void
+BeaconPayloadHeader::SetPndAddrFields (PendingAddrFields pndAddrFields)
+{
+  m_pndAddrFields = pndAddrFields;
+}
+
+SuperframeField
+BeaconPayloadHeader::GetSuperframeSpecField (void) const
+{
+  return m_superframeField;
+}
+
+GtsFields
+BeaconPayloadHeader::GetGtsFields (void) const
+{
+  return m_gtsFields;
+}
+
+PendingAddrFields
+BeaconPayloadHeader::GetPndAddrFields (void) const
+{
+  return m_pndAddrFields;
+}
+
+
+/***********************************************************
+ *                Command MAC Payload
+ ***********************************************************/
+
+CommandPayloadHeader::CommandPayloadHeader ()
+{
+  SetCommandFrameType (CMD_RESERVED);
+}
+
+
+CommandPayloadHeader::CommandPayloadHeader (enum MacCommand macCmd)
+{
+  SetCommandFrameType (macCmd);
+}
+
+NS_OBJECT_ENSURE_REGISTERED (CommandPayloadHeader);
+
+TypeId
+CommandPayloadHeader::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::CommandPayloadHeader")
+    .SetParent<Header> ()
+    .SetGroupName ("LrWpan")
+    .AddConstructor<CommandPayloadHeader> ()
+  ;
+  return tid;
+}
+
+TypeId
+CommandPayloadHeader::GetInstanceTypeId (void) const
+{
+  return GetTypeId ();
+}
+
+uint32_t
+CommandPayloadHeader::GetSerializedSize (void) const
+{
+  uint32_t size = 1;
+
+  return size;
+}
+
+void
+CommandPayloadHeader::Serialize (Buffer::Iterator start) const
+{
+  Buffer::Iterator i = start;
+  i.WriteU8 (m_cmdFrameId);
+}
+
+uint32_t
+CommandPayloadHeader::Deserialize (Buffer::Iterator start)
+{
+  Buffer::Iterator i = start;
+  m_cmdFrameId = i.ReadU8 ();
+
+  return i.GetDistanceFrom (start);
+}
+
+void
+CommandPayloadHeader::Print (std::ostream &os) const
+{
+  os << "| MAC Command Frame ID | = " << (uint32_t) m_cmdFrameId;
+}
+
+void
+CommandPayloadHeader::SetCommandFrameType (MacCommand macCommand)
+{
+  m_cmdFrameId = macCommand;
+}
+
+
+CommandPayloadHeader::MacCommand
+CommandPayloadHeader::GetCommandFrameType (void) const
+{
+  switch (m_cmdFrameId)
+    {
+    case 0x01:
+      return ASSOCIATION_REQ;
+      break;
+    case 0x02:
+      return ASSOCIATION_RESP;
+      break;
+    case 0x03:
+      return DISASSOCIATION_NOTIF;
+      break;
+    case 0x04:
+      return DATA_REQ;
+      break;
+    case 0x05:
+      return PANID_CONFLICT;
+      break;
+    case 0x06:
+      return ORPHAN_NOTIF;
+      break;
+    case 0x07:
+      return BEACON_REQ;
+      break;
+    case 0x08:
+      return COOR_REALIGN;
+      break;
+    case 0x09:
+      return GTS_REQ;
+      break;
+    default:
+      return CMD_RESERVED;
+    }
+}
+
+
+} // ns3 namespace
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/model/lr-wpan-mac-pl-headers.h ns-3.31/src/lr-wpan/model/lr-wpan-mac-pl-headers.h
--- ns-3.30.1/src/lr-wpan/model/lr-wpan-mac-pl-headers.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/lr-wpan/model/lr-wpan-mac-pl-headers.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,165 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 Ritsumeikan University, Shiga, Japan.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ *  Author: Alberto Gallegos Ramonet <ramonet@fc.ritsumei.ac.jp>
+ */
+
+#ifndef LR_WPAN_MAC_PL_HEADERS_H
+#define LR_WPAN_MAC_PL_HEADERS_H
+
+#include <ns3/header.h>
+#include <ns3/mac16-address.h>
+#include <ns3/mac64-address.h>
+#include "lr-wpan-fields.h"
+
+
+namespace ns3 {
+
+
+
+/**
+ * \ingroup lr-wpan
+ * Implements the header for the MAC payload beacon frame according to
+ * the IEEE 802.15.4-2011 Std.
+ */
+class BeaconPayloadHeader : public Header
+{
+
+public:
+  BeaconPayloadHeader ();
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  TypeId GetInstanceTypeId (void) const;
+  uint32_t GetSerializedSize (void) const;
+  virtual void Serialize (Buffer::Iterator start) const;
+  uint32_t Deserialize (Buffer::Iterator start);
+  void Print (std::ostream &os) const;
+  /**
+   * Set the superframe specification field to the beacon payload header.
+   * \param sfrmField The superframe specification field
+   */
+  void SetSuperframeSpecField (SuperframeField  sfrmField);
+  /**
+   * Set the superframe Guaranteed Time Slot (GTS) fields to the beacon payload header.
+   * \param gtsFields The GTS fields.
+   */
+  void SetGtsFields (GtsFields gtsFields);
+  /**
+   * Set the superframe Pending Address fields to the beacon payload header.
+   * \param pndAddrFields The Pending Address fields.
+   */
+  void SetPndAddrFields (PendingAddrFields pndAddrFields);
+  /**
+   * Get the superframe specification field from the beacon payload header.
+   * \return The superframe specification field
+   */
+  SuperframeField GetSuperframeSpecField (void) const;
+  /**
+   * Get the Guaranteed Time Slots (GTS) fields from the beacon payload header.
+   * \return The GTS fields.
+   */
+  GtsFields GetGtsFields (void) const;
+  /***
+   * Get the pending address fields from the beacon payload header.
+   * \return The Pending Address fields.
+   */
+  PendingAddrFields GetPndAddrFields (void) const;
+
+private:
+  /**
+   * Superframe Specification Field
+   */
+  SuperframeField m_superframeField;
+  /**
+   * GTS Fields
+   */
+  GtsFields m_gtsFields;
+  /**
+   * Pending Address Fields
+   */
+  PendingAddrFields m_pndAddrFields;
+
+};
+
+
+/**
+ * \ingroup lr-wpan
+ * Implements the header for the MAC payload command frame according to
+ * the IEEE 802.15.4-2011 Std.
+ */
+class CommandPayloadHeader : public Header
+{
+
+public:
+  /**
+   *  The MAC command frames.
+   *  See IEEE 802.15.4-2011, Table 5
+   */
+  enum MacCommand
+  {
+    ASSOCIATION_REQ      = 0x01,        //!< Association request (RFD true: Tx)
+    ASSOCIATION_RESP     = 0x02,        //!< Association response (RFD true: Rx)
+    DISASSOCIATION_NOTIF = 0x03,        //!< Disassociation notification (RFD true: TX, Rx)
+    DATA_REQ             = 0x04,        //!< Data Request (RFD true: Tx)
+    PANID_CONFLICT       = 0x05,        //!< Pan ID conflict notification (RFD true: Tx)
+    ORPHAN_NOTIF         = 0x06,        //!< Orphan Notification (RFD true: Tx)
+    BEACON_REQ           = 0x07,        //!< Beacon Request (RFD true: none )
+    COOR_REALIGN         = 0x08,        //!< Coordinator Realignment (RFD true: Rx)
+    GTS_REQ              = 0x09,        //!< GTS Request (RFD true: none)
+    CMD_RESERVED         = 0xff         //!< Reserved
+  };
+
+
+  CommandPayloadHeader (void);
+  /**
+   * Constructor
+   * \param macCmd the command type of this command header
+   */
+  CommandPayloadHeader (enum MacCommand macCmd);
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  TypeId GetInstanceTypeId (void) const;
+  uint32_t GetSerializedSize (void) const;
+  virtual void Serialize (Buffer::Iterator start) const;
+  uint32_t Deserialize (Buffer::Iterator start);
+  void Print (std::ostream &os) const;
+
+  /**
+   * Set the command frame type
+   */
+  void SetCommandFrameType (MacCommand  macCmd);
+  /**
+   * Get the command frame type
+   */
+  MacCommand GetCommandFrameType (void) const;
+
+
+private:
+  /** The command Frame Identifier*/
+  uint8_t m_cmdFrameId;
+
+};
+
+}  // namespace ns3
+
+#endif /* LR_WPAN_MAC_PL_HEADERS_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/model/lr-wpan-net-device.cc ns-3.31/src/lr-wpan/model/lr-wpan-net-device.cc
--- ns-3.30.1/src/lr-wpan/model/lr-wpan-net-device.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lr-wpan/model/lr-wpan-net-device.cc	2020-06-27 17:38:30.000000000 -0700
@@ -251,14 +251,43 @@
 LrWpanNetDevice::SetAddress (Address address)
 {
   NS_LOG_FUNCTION (this);
-  m_mac->SetShortAddress (Mac16Address::ConvertFrom (address));
+  if (Mac16Address::IsMatchingType (address))
+    {
+      m_mac->SetShortAddress (Mac16Address::ConvertFrom (address));
+    }
+  else if (Mac48Address::IsMatchingType (address))
+    {
+      uint8_t buf[6];
+      Mac48Address addr = Mac48Address::ConvertFrom (address);
+      addr.CopyTo (buf);
+      Mac16Address addr16;
+      addr16.CopyFrom (buf+4);
+      m_mac->SetShortAddress (addr16);
+      uint16_t panId;
+      panId = buf[0];
+      panId <<= 8;
+      panId |= buf[1];
+      m_mac->SetPanId (panId);
+    }
+  else
+    {
+      NS_ABORT_MSG ("LrWpanNetDevice::SetAddress - address is not of a compatible type");
+    }
 }
 
 Address
 LrWpanNetDevice::GetAddress (void) const
 {
   NS_LOG_FUNCTION (this);
-  return m_mac->GetShortAddress ();
+
+  if (m_mac->GetShortAddress () == Mac16Address ("00:00"))
+    {
+      return m_mac->GetExtendedAddress ();
+    }
+
+  Mac48Address pseudoAddress = BuildPseudoMacAddress (m_mac->GetPanId (), m_mac->GetShortAddress ());
+
+  return pseudoAddress;
 }
 
 bool
@@ -304,7 +333,10 @@
 LrWpanNetDevice::GetBroadcast (void) const
 {
   NS_LOG_FUNCTION (this);
-  return Mac16Address ("ff:ff");
+
+  Mac48Address pseudoAddress = BuildPseudoMacAddress (m_mac->GetPanId (), Mac16Address::GetBroadcast ());
+
+  return pseudoAddress;
 }
 
 bool
@@ -324,34 +356,11 @@
 Address
 LrWpanNetDevice::GetMulticast (Ipv6Address addr) const
 {
-  NS_LOG_FUNCTION (this);
-  /* Implementation based on RFC 4944 Section 9.
-   * An IPv6 packet with a multicast destination address (DST),
-   * consisting of the sixteen octets DST[1] through DST[16], is
-   * transmitted to the following 802.15.4 16-bit multicast address:
-   *           0                   1
-   *           0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5
-   *          +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
-   *          |1 0 0|DST[15]* |   DST[16]     |
-   *          +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
-   * Here, DST[15]* refers to the last 5 bits in octet DST[15], that is,
-   * bits 3-7 within DST[15].  The initial 3-bit pattern of "100" follows
-   * the 16-bit address format for multicast addresses (Section 12). */
-
-  // \todo re-add this once Lr-Wpan will be able to accept these multicast addresses
-  //  uint8_t buf[16];
-  //  uint8_t buf2[2];
-  //
-  //  addr.GetBytes(buf);
-  //
-  //  buf2[0] = 0x80 | (buf[14] & 0x1F);
-  //  buf2[1] = buf[15];
-  //
-  //  Mac16Address newaddr = Mac16Address();
-  //  newaddr.CopyFrom(buf2);
-  //  return newaddr;
+  NS_LOG_FUNCTION (this << addr);
 
-  return Mac16Address ("ff:ff");
+  Mac48Address pseudoAddress = BuildPseudoMacAddress (m_mac->GetPanId (), Mac16Address::GetMulticast (addr));
+
+  return pseudoAddress;
 }
 
 bool
@@ -385,7 +394,19 @@
     }
 
   McpsDataRequestParams m_mcpsDataRequestParams;
-  m_mcpsDataRequestParams.m_dstAddr = Mac16Address::ConvertFrom (dest);
+
+  Mac16Address dst16;
+  if (Mac48Address::IsMatchingType (dest))
+    {
+      uint8_t buf[6];
+      dest.CopyTo (buf);
+      dst16.CopyFrom (buf+4);
+    }
+  else
+    {
+      dst16 = Mac16Address::ConvertFrom (dest);
+    }
+  m_mcpsDataRequestParams.m_dstAddr = dst16;
   m_mcpsDataRequestParams.m_dstAddrMode = SHORT_ADDR;
   m_mcpsDataRequestParams.m_dstPanId = m_mac->GetPanId ();
   m_mcpsDataRequestParams.m_srcAddrMode = SHORT_ADDR;
@@ -453,7 +474,7 @@
 {
   NS_LOG_FUNCTION (this);
   // TODO: Use the PromiscReceiveCallback if the MAC is in promiscuous mode.
-  m_receiveCallback (this, pkt, 0, params.m_srcAddr);
+    m_receiveCallback (this, pkt, 0, BuildPseudoMacAddress (params.m_srcPanId, params.m_srcAddr));
 }
 
 bool
@@ -463,6 +484,27 @@
   return false;
 }
 
+Mac48Address
+LrWpanNetDevice::BuildPseudoMacAddress (uint16_t panId, Mac16Address shortAddr) const
+{
+  NS_LOG_FUNCTION (this);
+
+  uint8_t buf[6];
+
+  buf[0] = panId >> 8;
+  // Make sure the U/L bit is set
+  buf[0] |= 0x02;
+  buf[1] = panId & 0xff;
+  buf[2] = 0;
+  buf[3] = 0;
+  shortAddr.CopyTo (buf+4);
+
+  Mac48Address pseudoAddress;
+  pseudoAddress.CopyFrom (buf);
+
+  return pseudoAddress;
+}
+
 int64_t
 LrWpanNetDevice::AssignStreams (int64_t stream)
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/model/lr-wpan-net-device.h ns-3.31/src/lr-wpan/model/lr-wpan-net-device.h
--- ns-3.30.1/src/lr-wpan/model/lr-wpan-net-device.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lr-wpan/model/lr-wpan-net-device.h	2020-06-27 17:38:30.000000000 -0700
@@ -191,6 +191,25 @@
   void CompleteConfig (void);
 
   /**
+   * Builds a "pseudo 48-bit address" from the PanId and Short Address
+   * The form is PanId : 0x0 : 0x0 : ShortAddress
+   *
+   * The address follows RFC 4944, section 6, and it is used to build an
+   * Interface ID.
+   *
+   * The Interface ID should have its U/L bit is set to zero, to indicate that
+   * this interface ID is not globally unique.
+   * However, the U/L bit flipping is performed when the IPv6 address is created.
+   *
+   * As a consequence, here we set it to 1.
+   *
+   * \param panId The PanID
+   * \param shortMac The Short MAC address
+   * \return a Pseudo-Mac48Adress
+   */
+  Mac48Address BuildPseudoMacAddress (uint16_t panId, Mac16Address shortAddr) const;
+
+  /**
    * The MAC for this NetDevice.
    */
   Ptr<LrWpanMac> m_mac;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/model/lr-wpan-phy.h ns-3.31/src/lr-wpan/model/lr-wpan-phy.h
--- ns-3.30.1/src/lr-wpan/model/lr-wpan-phy.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lr-wpan/model/lr-wpan-phy.h	2020-06-27 17:38:30.000000000 -0700
@@ -432,6 +432,7 @@
 
   /**
    * implement PLME SetAttribute confirm SAP
+   * bit rate is in kbit/s.  Symbol rate is in ksymbol/s.
    * @param isData is true for data rate or false for symbol rate
    * @return the rate value of this PHY
    */
@@ -492,7 +493,8 @@
 protected:
   /**
    * The data and symbol rates for the different PHY options.
-   * See Table 2 in section 6.1.2 IEEE 802.15.4-2006
+   * See Table 2 in section 6.1.2 IEEE 802.15.4-2006.
+   * Bit rate is in kbit/s.  Symbol rate is in ksymbol/s.
    */
   static const LrWpanPhyDataAndSymbolRates dataSymbolRates[7];
   /**
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/test/lr-wpan-ack-test.cc ns-3.31/src/lr-wpan/test/lr-wpan-ack-test.cc
--- ns-3.30.1/src/lr-wpan/test/lr-wpan-ack-test.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lr-wpan/test/lr-wpan-ack-test.cc	2020-06-27 17:38:30.000000000 -0700
@@ -106,7 +106,7 @@
 void
 LrWpanAckTestCase::DataIndication (LrWpanAckTestCase *testCase, Ptr<LrWpanNetDevice> dev, McpsDataIndicationParams params, Ptr<Packet> p)
 {
-  if (dev->GetAddress () == Mac16Address ("00:02"))
+  if (dev->GetMac ()->GetShortAddress () == Mac16Address ("00:02"))
     {
       Ptr<Packet> p = Create<Packet> (10);  // 10 bytes of dummy data
       McpsDataRequestParams params;
@@ -129,7 +129,7 @@
 void
 LrWpanAckTestCase::DataConfirm (LrWpanAckTestCase *testCase, Ptr<LrWpanNetDevice> dev, McpsDataConfirmParams params)
 {
-  if (dev->GetAddress () == Mac16Address ("00:01"))
+  if (dev->GetMac ()->GetShortAddress () == Mac16Address ("00:01"))
     {
       testCase->m_requestAckTime = Simulator::Now ();
     }
